package cn.com.ctop.toutiao.modules.batch.controller;

import cn.com.ctop.toutiao.modules.material.entity.ByteDanceAdvertisePlan;
import cn.com.ctop.toutiao.modules.material.service.IByteDanceAdvertisePlanService;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;


@Slf4j
@RestController
@RequestMapping("/bytedance/batch")
public class ByteDanceBatchController {

    @Autowired
    IByteDanceAdvertisePlanService byteDanceAdvertisePlanService;

    /**
     *  批量创建计划
     * @param byteDanceAdvertisePlan
     * @param requestBody
     * @return
     */
    @PostMapping(value = "/create/advertiserPlan")
    public Result<List<ByteDanceAdvertisePlan>> add(@RequestBody ByteDanceAdvertisePlan byteDanceAdvertisePlan,
                                                    @RequestBody JSONObject requestBody) {
        Result<List<ByteDanceAdvertisePlan>> result = new Result<>();
        List<ByteDanceAdvertisePlan> byteDanceAdvertisePlanList= new ArrayList<>();
        if(requestBody.getJSONArray("accountIds").isEmpty()){
            log.error("批量创建计划未选择账户");
        }
        requestBody.getJSONArray("accountIds").forEach(it->{
            byteDanceAdvertisePlan.setAccountId(it.toString());
            try {
                //TODO 需要先存入头条后台
                byteDanceAdvertisePlanService.save(byteDanceAdvertisePlan);
                byteDanceAdvertisePlanList.add(byteDanceAdvertisePlan);
                result.success("添加成功！");
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                result.error500("操作失败");
            }
        });
        result.setResult(byteDanceAdvertisePlanList);
        return result;
    }

    /**
     *  批量创建创意
     */
}
